2007-04-15  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (cogre-graph::cogre-save): Deleted from this file.
	(cogre-semantic-uml-graph::cogre-save): Allow saving.
	(cogre-semantic-class::initialize-instance): Copy the tag found.

	* uml-create.el (cogre-graph::cogre-save):
	Add comment about why we can't save.

	* cogre.el (cogre-load-graph): Stop using a temporary graph.

2007-03-18  Eric M. Ludlam  <zappo@gnu.org>

	* Makefile (LOADPATH): Stripped down version
	(wy): Spelling fix.
	(autoloads, init, dot, Mode, hacks, COGRE, dist):
	Various changes from EDE patches.

2007-02-19  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (semanticdb-find): Add require
	(cogre-semantic-class::initialize-instance)
	(cogre-read-class-name)
	(cogre-uml-quick-class)
	(cogre-uml-create): Convert to new semanticdb search.

	* cogre-mode.el (cogre-mode): Add semantic-match-any-mode feature.

	* cogre.el (cogre-load, picture-hack): Add requires for byte-comp.
	(cogre): Add to tools group.

2007-02-03  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el: (cogre-semantic-class::cogre-uml-stoken->uml):
	Disable images in semantic formatted strings.

2005-09-30  Eric M. Ludlam  <zappo@gnu.org>

	* wisent-dot.wy, wisent-dot.el, uml-create.el, picture-hack.el, cogre-uml.el, cogre-mode.el, cogre-load.el, cogre.el:
	Update all GPL headers with script from savannah.gnu.org.

2005-02-03  Eric M. Ludlam  <zappo@gnu.org>

	* Project.ede ("COGRE"): Update version number.

	* Makefile (VERSION, Makefile): Updated from project file.

	* cogre.el (cogre-version): Update version number.

2004-09-28  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (semantic-grammar-batch-build-packages):
	Use new semantic :type.

2004-05-25  David Ponce  <david@dponce.com>

	* Makefile: Re-generated to start Emacs with --no-site-file.

2004-04-11  Eric M. Ludlam  <zappo@gnu.org>

	* Makefile (dist): Add autoloads

2004-04-06  Eric M. Ludlam  <zappo@gnu.org>

	* Makefile (dist): Distribute the autoload file

2004-03-30  Eric M. Ludlam  <zappo@gnu.org>

	* Makefile (clean): Update info garbage pattern.

2004-03-28  David Ponce  <david@dponce.com>

	* Makefile: Rebuild.

	* Project.ede (wisent): Rename target to "wy".
	(COGRE): Remove semantic-el dependency.  Add dependency on
	inversion and speedbar.

	* cogre-uml.el (cogre-class): Doc fix.

2004-03-25  David Ponce  <david@dponce.com>

	* wisent-dot.el (semantic-wisent): Require instead of wisent-bovine.

2004-02-29  Eric M. Ludlam  <zappo@gnu.org>

	* INSTALL: Revamped. We are a part of a CEDET install now.

2004-02-02  David Ponce  <david@dponce.com>

	* wisent-dot.el (semantic-tag-components):
	New override for `graphviz-dot-mode'.

2004-01-23  David Ponce  <david@dponce.com>

	* wisent-dot.wy: Some code cleanup.
	(<keyword>, <symbol>, <string>, <number>): Declare as type.
	(<punctuation>, <block>): Use type defaults.
	(epilogue): Define `wisent-dot-lexer' here.

	* wisent-dot.el (wisent-dot-lexer): Remove.  Defined in grammar.

2004-01-15  Eric M. Ludlam  <zappo@gnu.org>

	* wisent-dot.el (semantic-lex-dot-blocks): Deleted.
	(wisent-dot-lexer): Remove old style analyzers. Replace with
	auto-generated ones.

	* wisent-dot.wy (punctuation, block):
	Use new %type command to build lexers.

2003-10-02  Eric M. Ludlam  <zappo@gnu.org>

	* Project.ede: Now a meta-subproject.

	* Makefile (dist): Remove local creation of tar file.

2003-09-24  Eric M. Ludlam  <zappo@gnu.org>

	* Project.ede, Makefile, cogre.el: Update version to 0.4beta1.

2003-09-18  David Ponce  <david@dponce.com>

	* Makefile: Re-generated.

	* Project.ede (init): New target.

2003-09-17  David Ponce  <david@dponce.com>

	* cogre-load.el: New file.

	* Makefile: Re-generated.

	* Project.ede (autoloads): Change cogre-defs.el by cogre-loaddefs.el.

2003-09-16  David Ponce  <david@dponce.com>

	* Makefile: Re-generated.

	* Project.ede (target COGRE):
	Remove non existing file cogre-lay.el from target.

2003-09-14  David Ponce  <david@dponce.com>

	* wisent-dot.el (wisent-dot-setup-parser): Fix use of obsolete names.

2003-09-10  David Ponce  <david@dponce.com>

	* Makefile: Re-generated.

2003-09-07  Eric M. Ludlam  <zappo@gnu.org>

	* Makefile: Makefile.

	* Project.ede ("wisent"): New
	("autoloads"): New
	("dot"): New
	("mode"): New.

	* uml-create.el:
	(initialize-instance, cogre-token->uml-function, cogre-uml-stoken->uml)
	(cogre-uml-browse-token-highlight-hook-fn, cogre-uml-source-marker)
	(cogre-read-class-name, cogre-uml-quick-class): New semantic API

	* cogre-mode.el: Coped elements from cogre.el

	* cogre.el (cogre-box-face, cogre-box-first-face, cogre-box-last-face):
	Removed
	(cogre-graph-element): made abstract
	(cogre-node): made abstract
	(cogre-link): made abstract
	(cogre-mode-map, cogre-substitute, cogre-insert-class-list)
	(cogre-insert-forms-menu, cogre-change-forms-menu): Removed
	(cogre): autoload cookie.
	(cogre-mode, & many others): Removed
	(cogre-default-node, cogre-default-link): Use 4th arg to
	eieio-read-subclass.
	(cogre-load-graph): autoload

	* wisent-dot.wy: Removed obsolete code.

	* wisent-dot.el (wisent-dot-automaton, other autogen): Deleted
	(wisent-dot-setup-parser): Removed autogen parts, copied in parts
	that used to be in the .wy file.

2003-07-23  Eric M. Ludlam  <zappo@gnu.org>

	* wisent-dot.wy (languagemode): Set to graphviz-dot-mode

2003-03-26  Eric M. Ludlam  <zappo@gnu.org>

	* test.dot: Sample dot file for dot parser.

	* wisent-dot.el:
	(wisent-dot-automaton, wisent-dot-keywords, wisent-dot-tokens)
	(wisent-dot-setup-parser): Updated from grammar.

	* wisent-dot.wy (FONTNAME, FONTSIZE): New tokens.
	(DILINK, LINK): Now of punctuation type.
	(number): New token class.
	(graph-contents): Added graph-attributes
	(graph-attributes): New
	(links): Optional semicolon and attribute vector.

	* wisent-dot.el:
	Lexer, Grammar and support for parsing graphviz dot files.

	* wisent-dot.wy: Grammar file for graphviz dot files

2003-02-25  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (initialize-instance):
	Use new function that calculates externally
	defined children of a type.
	(cogre-uml-quick-class): typo

2001-12-05  Eric M. Ludlam  <zappo@gnu.org>

	* Project.ede: Version.
	New layout code.

	* uml-create.el (cogre-save): New method.
	(initialize-instance): Enable classes and structures.
	Add default name for unfound classes in semantic.
	(cogre-uml-stoken->uml): Get buffer from objectified class.
	(cogre-uml-quick-class): Get the superclass instead of just the parent.

	* picture-hack.el (picture-insert): Fix for older versions of Emacs.

	* cogre-uml.el (cogre-class): Add :custom specifiers to some slots.

	* cogre.el (cogre-graph): Added extension.
	(cogre-node):  Remove initargs from fields not to be saved.
	(cogre-link): Enable STRINGS as node entries for intermediate save state.
	(cogre-loading-from-file): New variable.
	(cogre-mode-map): Supress the keymap. Add save command.
	(cogre-mode-menu): Added Save and Save As entries.
	(cogre-map-elements, cogre-map-graph-elements): New fcn
	(initialize-instance): Do not initialize when loading from a file.
	(cogre-render-buffer): Use new map-lements command.
	(cogre-element-pre-serialize, cogre-element-post-serialize): New methods.
	(cogre-save-graph-as, cogre-save-graph, cogre-load-graph): New commands.

2001-08-17  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (cogre-uml-browse-token-hook): New hook.
	(cogre-uml-browse-token-highlight-hook-fn): New function for above.
	(cogre-uml-source-marker): Use hook instead of always highlighting a token.

	* uml-create.el (cogre-token->uml-function): New variable.
	(cogre-uml-stoken->uml): Use above to generate text.
	(cogre-uml-source-marker): Momentary highlight tokens.

	* picture-hack.el (picture-insert):
	Fix move-to-column typo from previous checkin.

	* cogre.el: Update version.
	(eieio-base): require
	(cogre-custom-originating-graph-buffer): New local variable.
	(cogre-activate): Track the originating buffer before customizing.
	(eieio-done-customizing::cogre-graph-element): Set buffer to the
	graph before forcing a re-render.

2001-08-14  Eric M. Ludlam  <zappo@gnu.org>

	* picture-hack.el:
	Use `move-to-column' instead of `move-to-column-force' for backward
	compatibility.

2001-08-08  Eric M. Ludlam  <zappo@gnu.org>

	* Project.ede: Project file for cogre.

	* cogre.texi: Outline of a cogre manual

	* picture-hack.el (picture-insert-rectangle):
	Added Emacs 21 compatibility comment.
	(clear-rectangle): New compatibility function.

	* cogre.el: Support latest EIEIO changes.
	(cogre-new-node): Pass prefix arg to `cogre-default-node'.
	(cogre-new-link): Pass prefix arg to `cogre-default-link'.
	(cogre-layout): Remove these methods.

2001-07-20  Eric M. Ludlam  <zappo@gnu.org>

	* cogre-uml.el: Added comment about ASCII UML.

2001-07-12  Eric M. Ludlam  <zappo@gnu.org>

	* cogre.el: Use :class instead of class for allocation of slots.

2001-06-12  Eric M. Ludlam  <zappo@gnu.org>

	* INSTALL: Installation instructions for COGRE.

2001-06-06  Eric M. Ludlam  <zappo@gnu.org>

	* picture-hack.el: (Colin Marquardt):
	Added XEmacs compatibility functions.

2001-06-05  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (cogre-uml-stoken->uml):
	Call abbreviate token from the originating buffer.

2001-05-21  Eric M. Ludlam  <zappo@gnu.org>

	* cogre.el (cogre-string-with-face):
	Fixed bug in last fix that colorized everything.

	* uml-create.el: do not use window-list, it is Emacs 21 only.

	* cogre.el:
	Stopped using `plist-member' which appears to be Emacs 21 only.

2001-05-19  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el (cogre-semantic-uml-graph): New class.
	(cogre-insert-clas-slist:cogre-semantic-uml-graph): New method.
	(cogre-uml-source-marker:cogre-semantic-class): New method
	(cogre-uml-source-display): Split into cogre-uml-source-marker for
	getting the position to jump to.
	(cogre-activate:cogre-semantic-class): New method.
	(cogre-uml-quick-class): Make sure all tokens are in buffers.
	Create the graph from cogre-semantic-uml-graph.

	* cogre.el (cogre-node): Fixed documentation.
	(cogre-substitute): Doc fix.
	(cogre-mode-map): Added RETURN binding to edit/view.
	(cogre-insert-class-list:cogre-graph): New method
	(cogre-insert-forms-menu): Call graph method for things to insert.
	(cogre): accept an argument for the class of the graph to create.
	(cogre-activate-element): New function.
	(cogre-activate:cogre-graph-element): New method.

2001-05-18  Eric M. Ludlam  <zappo@gnu.org>

	* uml-create.el: Code from `cogre-uml.el' specific to semantic.
	New code handles graph/source interactions.

	* cogre-uml.el: Moved out semnatic specific UML into `uml-create.el'
	(cogre-uml-stoken->uml): New function.
	(cogre-node-slots): Use above.

	* cogre.el (*-face): Under/Over lines match default foreground color.
	(cogre-link): Types are now the explicit class name (return of eieio feature).
	(cogre-move-node): Inhibit motion hooks.
	(cogre-render-buffer): Inhibit motion hooks.
	(cogre-entered, cogre-left: cogre-graph-element): New methods.
	(cogre-node-rebuild): Use underlining when possible instead of overlining.
	(cogre-string-with-face): Propagate properties on passed in strings.
	Conglomerate new face with old faces.

2001-05-09  Eric M. Ludlam  <zappo@gnu.org>

	* cogre.el: Converted to use the new eieio-named base class.
	Added "Delete" to the menu.

	* cogre-uml.el: Converted to use the new eieio-named base class.

2001-05-07  Eric M. Ludlam  <zappo@gnu.org>

	* cogre-uml.el (cogre-class): Set the alignment to left.
	(cogre-node-slots): Use the new uml-abbreviate method.
	(cogre-read-class-name): Fix bugs w/ current class under cursor.
	(cogre-uml-quick-class): Added recentering code.

	* cogre.el (cogre-horizontal-margins, cogre-vertical-margins):
	New variables
	(cogre-graph-element): Added `menu' field.
	(cogre-node): Added `alignment' field.
	Added menu to minor mode keymap.
	(cogre-insert-forms-menu, cogre-change-forms-menu): New fcn.
	(cogre-new-node,cogre-new-link): Only rerender if interactive.
	(cogre-move-node): Pulled out guts into a method.
	(cogre-move, cogre-move-detla): New Node mehtods.
	(cogre-rebuild:cogre-node): Added alignment when rebuilding the rect.
	(cogre-string-with-face): Handle an alignment argument.
	(cogre-current-element): Make the passed in point optional.

2001-05-02  Eric M. Ludlam  <zappo@gnu.org>

	* cogre-uml.el: Messed with some link icons.
	Added a class slot to the class node.
	Added cogre-uml-quick-class, and got most of it working.

2001-04-25  Eric M. Ludlam  <zappo@gnu.org>

	* cogre-uml.el: Added new default names to nodes.
	Initialize a CLASS node by asking for a class, derived from semantic,
	from which the the details are created.
	Fixed typo for ratio.
	Fixed `cogre-read-class-name'.

	* cogre.el:
	Added a layout direction to links so they can choose a preferred layout.
	Moved cogre-substitute so it wouldn't throw an error.
	Always truncate lines in a graph.
	Fixed bug when choosing the face of the last slot in a box.
	Updated widest-string method to also take slots into account.
	Fixed anchor calculation for endpoint down links.
	Added mock functions for the layout engine.

2001-04-24  Eric M. Ludlam  <zappo@gnu.org>

	* cogre-uml.el: *** empty log message ***

2001-04-23  Eric M. Ludlam  <zappo@gnu.org>

	* cogre.el:
	Allow links to contain a start/end which is a child of cogre-node.
	Added support for start/end glyps on lines.
	Added new fns to handle default node/link insertion.  Thus, you will
	always insert the same type of node as done previously unless you
	explicitly call something to set the defualt node, or use c-u prefix.

2001-04-18  Eric M. Ludlam  <zappo@gnu.org>

	* cogre.el: Moved many bits to picture-hack.el where appropriate.
	Added a preference-ratio and a stop-position to links.
	Added a DELETE command to delete items.
	Added more *-at-point-interactive functions.
	Support links when TABing between items.
	Added utils for calculating distances and anchors between nodes.
	Fixed up link render to be simpler with the new utils.

	* picture-hack.el: Hacks to override and augment picture.el

2001-04-14  Eric M. Ludlam  <zappo@gnu.org>

	* cogre.el: *** empty log message ***

